/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

/**
 * @module lib/rules/protect/in-filters/Object
 * InFilter hooks for Object methods.
 */

const _ = require('lodash');

const BaseSensor = require('../../hooks/frameworks/base');
const constants = require('../../constants');
const patcher = require('../../hooks/patcher');
const { PATCH_TYPES } = require('../../constants');
const { emitSinkEvent } = require('../../hooks/frameworks/common');

const ID = 'eval';
const { SINK_TYPES } = constants;

class EvalSensor extends BaseSensor {
  constructor(agent) {
    super({ id: ID, agent });
  }

  install() {
    if (!_.get(global, 'ContrastMethods.__contrastEval')) {
      throw new Error('Cannot install `eval` sensor - Contrast method DNE.');
    }

    patcher.patch(global.ContrastMethods, '__contrastEval', {
      name: 'global.ContrastMethods',
      patchType: PATCH_TYPES.PROTECT_SINK,
      alwaysRun: true,
      pre: (wrapCtx) => {
        const data = wrapCtx.args[0];
        emitSinkEvent(data, SINK_TYPES.CODE_STRING, ID);
      }
    });

    return this;
  }
}

module.exports = EvalSensor;
